<ng-container
  *subscribe="updateRequestDatasetMutation.result$ as requestDataset"
>
  <ngx-loading [show]="requestDataset.isLoading" />
</ng-container>

@if (vm$ | async; as vm) {
  <div [ngClass]="['desk-list-request-opendata', jds.tablePaging]">
    <!-- List Request Satu Data -->
    @if (vm.listRequestDatasetOpenData; as listRequest) {
      @switch (listRequest.status) {
        @case ('loading') {
          <ng-container *ngTemplateOutlet="skeleton" />
        }

        @case ('success') {
          @if (listRequest.isFetching) {
            <ng-container *ngTemplateOutlet="skeleton" />
          } @else if (listRequest.data.list.length > 0) {
            @for (
              row of listRequest.data.list;
              track row.id;
              let isLast = $last
            ) {
              <div [ngClass]="[jds.fs(14), jds.text('gray900')]">
                <div
                  [ngClass]="[
                    jds.d('flex'),
                    jds.alignItems('center'),
                    jds.mb(14)
                  ]"
                  [style.gap.px]="10"
                >
                  <span>Tiket No. {{ row.id }}</span>

                  <span
                    [colorScheme]="getBadgeColor(row.status)"
                    [isRounded]="true"
                    jdsBiBadge
                  >
                    {{ getBadgeName(row.status) }}
                  </span>
                </div>

                <div
                  [ngClass]="[jds.fs(16), jds.fw('bold'), jds.mb(14)]"
                  [style.fontFamily]="'Roboto'"
                >
                  {{ row.judul_data }}
                </div>

                <div [ngClass]="[jds.mb(14), jds.text('gray700')]">
                  <span>
                    Diajukan:
                    {{
                      moment(row.datetime).locale('id').format('DD MMMM YYYY')
                    }}
                  </span>
                  <span [ngClass]="[jds.ms(8)]">|</span>
                  <span [ngClass]="[jds.ms(8)]">
                    {{ moment(row.cdate).locale('id').fromNow() }}
                  </span>
                  @if (row.status === 4) {
                    @if (getAuthority(row.notes)) {
                      <span [ngClass]="[jds.ms(8)]">|</span>
                      <span
                        [ngClass]="[
                          jds.ms(8),
                          jds.py(0),
                          jds.px(5.5),
                          getAuthorityValue(row.notes)
                            ? jds.bg(jdsBiColor.blue['100'])
                            : jds.bg(jdsBiColor.red['100']),
                          getAuthorityValue(row.notes)
                            ? jds.text(jdsBiColor.blue['800'])
                            : jds.text(jdsBiColor.red['800'])
                        ]"
                        [style.borderColor]="
                          getAuthorityValue(row.notes)
                            ? jdsBiColor.blue['100']
                            : jdsBiColor.red['100']
                        "
                        [isRounded]="true"
                        jdsBiBadge
                      >
                        {{ getAuthorityName(row.notes) }}
                      </span>
                    }
                  }
                </div>

                <div
                  [ngClass]="[jds.d('flex'), jds.mb(14)]"
                  [style.gap.px]="8"
                >
                  <button
                    [ngClass]="[jds.py(5), jds.px(9)]"
                    [colorScheme]="'gray'"
                    [variant]="'outline'"
                    (click)="onDetail(row.id)"
                    jdsBiButton
                    type="button"
                  >
                    <jds-bi-icon
                      [ngClass]="[jds.me(6)]"
                      [size]="14"
                      name="eye"
                    />
                    <span>Detail</span>
                  </button>

                  <button
                    [ngClass]="[jds.py(5), jds.px(9)]"
                    [colorScheme]="'gray'"
                    [variant]="'outline'"
                    (click)="onTracking(row.id)"
                    jdsBiButton
                    type="button"
                  >
                    <jds-bi-icon
                      [ngClass]="[jds.me(6)]"
                      [size]="13"
                      name="circle-info"
                    />
                    <span>Lacak</span>
                  </button>

                  @if (row.status === 1) {
                    <button
                      [ngClass]="[jds.py(5), jds.px(9)]"
                      [colorScheme]="'yellow'"
                      [variant]="'input'"
                      (click)="onProcess(row.id)"
                      jdsBiButton
                      type="button"
                    >
                      <jds-bi-icon
                        [ngClass]="[jds.me(6)]"
                        [size]="16"
                        name="check"
                      />
                      <span>Proses</span>
                    </button>
                  }

                  @if (row.status === 2) {
                    <button
                      [ngClass]="[jds.py(5), jds.px(9)]"
                      [colorScheme]="'green'"
                      [variant]="'input'"
                      (click)="onFinish(row.id)"
                      jdsBiButton
                      type="button"
                    >
                      <jds-bi-icon
                        [ngClass]="[jds.me(6)]"
                        [size]="16"
                        name="check-double"
                      />
                      <span>Selesai</span>
                    </button>
                  }

                  @if (row.status === 1 || row.status === 2) {
                    <button
                      [ngClass]="[jds.py(5), jds.px(9)]"
                      [colorScheme]="'red'"
                      [variant]="'input'"
                      (click)="onDecline(row.id)"
                      jdsBiButton
                      type="button"
                    >
                      <jds-bi-icon
                        [ngClass]="[jds.me(6)]"
                        [size]="10"
                        name="xmark"
                      />
                      <span>Tolak</span>
                    </button>
                  }

                  @if (row.status === 4) {
                    @if (getAuthority(row.notes)) {
                      @if (getAuthorityValue(row.notes)) {
                        <a
                          [ngClass]="[jds.py(5), jds.px(9)]"
                          [colorScheme]="colorScheme"
                          [routerLink]="['/my-dataset/add']"
                          jdsBiButton
                        >
                          <span>Perbarui</span>
                        </a>
                      }
                    }
                  }
                </div>

                @if (!isLast) {
                  <hr [ngClass]="[jds.mt(8), jds.mb(16)]" />
                }
              </div>
            }

            <jds-bi-pagination
              [colorScheme]="colorScheme"
              [perPageItems]="perPageItems"
              [pagination]="listRequest.data.pagination"
              [perPage]="vm.filterPerPage"
              [page]="vm.filterCurrentPage"
              (filterPerPage)="filterPerPage($event)"
              (filterPage)="filterPage($event)"
            />
          } @else {
            Tidak ada Data.
          }
        }
      }
    }
  </div>

  <app-desk-modal-request-opendata-detail />
  <app-modal-request-opendata-tracking
    [historyData]="vm.historyRequestDatasetOpenData"
  />
  <app-desk-modal-request-opendata-decline />
  <app-desk-modal-request-opendata-finish />
}

<ng-template #skeleton>
  @for (number of [0, 1, 2, 3, 4]; track $index; let isLast = $last) {
    @for (number of [20, 80, 30, 50]; track $index) {
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: number + '%',
            'border-radius': '0',
            height: '20px',
            'margin-bottom': '5px'
          }"
        />
      </div>
    }

    @if (!isLast) {
      <hr [ngClass]="[jds.mt(8), jds.mb(16)]" />
    }
  }
</ng-template>
